// ==============================================================
// CBP_2403_R_EncoderTest
// 09-10-21
// From CBP_FBO 
// Sends counts to Serial Monitor
// ==============================================================

#include <Servo.h>                  

// Define pins ---------------
#define ServoL_pin 13
#define ServoR_pin 12
#define EncoderL_pin 19
#define EncoderR_pin 20

// Define constants ----------
#define DEBUG true
#define wheelDiam 66.0
#define wheelRad (wheelDiam/2.0)
#define axleLen 104.0
#define dx ((PI*wheelDiam)/64.0)

// Global variables ----------
Servo servoL;
Servo servoR; 
float driveL, driveR;

// Variables for this activity
volatile unsigned long countL = 0;
volatile unsigned long countR = 0;
float drive;

void setup() {
  Serial.begin(9600);
  cprintf(">>> Initializing stuff ..................\n"); 

  pinMode(EncoderL_pin,INPUT);
  pinMode(EncoderR_pin,INPUT);
  attachInterrupt(digitalPinToInterrupt(EncoderL_pin),ISRoutineL,CHANGE);
  attachInterrupt(digitalPinToInterrupt(EncoderR_pin),ISRoutineR,CHANGE);
  
  cprintf(">>> Pausing 2 secs ......................\n");
  delay(2000);
  cprintf(">>> Starting  ...........................\n");
  cprintf("dx = %f\n",dx);
  
  countL = 0;
  countR = 0;
 
}

void loop() {
  cprintf(">>> In loop -------------\n");
  //cprintf("countL = %l, countR = %l\n",countL,countR);  
  delay(2000);
}

void ISRoutineL() { 
  countL++;
  //cprintf(">>> ISRoutineL()\n");  
}

void ISRoutineR() {
  countR++;    
  //cprintf(">>>ISRoutineR()\n");
}

void driveServos(float _driveL, float _driveR) {
  servoL.writeMicroseconds(1500 + (int)_driveL);
  servoR.writeMicroseconds(1500 - (int)_driveR);
}
