// =========================================================
// CBP_2403_R_StLine_FSM
// 10-10-21
// From CBP_FBO StLine_Naieve 31-05-21
// Moves forward specified desiredDist using ticks
// =========================================================

#include <Servo.h>                           

// Define pins ---------------
#define ServoL_pin 13
#define ServoR_pin 12
#define EncoderL_pin 19
#define EncoderR_pin 20

// Define constants ----------
#define DEBUG true
#define wheelDiam 66.0
#define wheelRad (wheelDiam/2.0)
#define axleLen 104.0
#define dx ((PI*wheelDiam)/64.0)

// States ------------------------
#define STATE_SETUP 1
#define STATE_MEASURE 2
#define STATE_RUN 3
#define STATE_DONE 4

// Global variables ----------
Servo servoL;
Servo servoR; 
float driveL, driveR;

// Variables for this activity
volatile unsigned long countL = 0;
volatile unsigned long countR = 0;

float drive;
float desiredDist;
unsigned long nL,nR;
float nLf, nRf;

int state;

void setup() {
  Serial.begin(9600);
  cprintf(">>> Initializing stuff ..................\n"); 
 // servoL.attach(ServoL_pin);                         
 // servoR.attach(ServoR_pin);  
 // driveServos(0.0,0.0);

  pinMode(EncoderL_pin,INPUT);
  pinMode(EncoderR_pin,INPUT);
  attachInterrupt(digitalPinToInterrupt(EncoderL_pin),ISRoutineL,CHANGE);
  attachInterrupt(digitalPinToInterrupt(EncoderR_pin),ISRoutineR,CHANGE);
  
  cprintf(">>> Pausing 2 secs ......................\n");
  delay(2000);
  cprintf(">>> Starting  ...........................\n");
  
  countL = 0;
  countR = 0;
  
  drive = 20;
  

             
  servoL.attach(ServoL_pin);                         
  servoR.attach(ServoR_pin);  
  driveServos(0.0,0.0);            

  cprintf("Transiting to STATE_SETUP\n");
  state = STATE_SETUP;
}

void loop() {

  switch(state) {
    case STATE_SETUP:
      drive = 20;
      // Set your desired distance --------
      // desiredDist = 
      // nRf etc calculations
      // nLf = 
      // nRf = 
      // nL = 
      // nR = 
      if(DEBUG)
        cprintf("dx = %f, nLf = %f, nRf = %f,nL = %l, nr = %l\n",
                dx,nLf,nRf,nL,nR);
      if(DEBUG) 
        cprintf(">>> Attaching servos ....................\n");      
      cprintf("Transiting to STATE_MEASURE\n");
      // Transit ------------
      // state = 
      break;
      
    case STATE_MEASURE:
      // driveL = 
      // driveR = 
      // call to drive servos
      // Insert the condition (replace true)
       if( true  ) {
        // stop servos 
        // calc new driveL = 
      
        if(DEBUG)cprintf("Actual counts: countL = %l, countR = %l\n",
                         countL,countR);
        if(DEBUG) cprintf("Adjusted drives: drive: = %f, driveR = %f\n",
                         driveL,driveR);
        countL = 0;
        countR = 0;
        cprintf("delaying 4 seconds\n");
        delay(4000);
        // Traansit 
        // state = 
    }
    break;
    case STATE_RUN:
      // call to drive the servos 
      // Insert the condition (replace true)
       if(true )  {
        cprintf("countL = %l, countR = %l\n",countL,countR);
        state = STATE_DONE;
      }
      break;
    case STATE_DONE:
      // stop the servos 
      // detatch the servos 
      break;  
  }
}

void ISRoutineL() {
  countL++;
}

void ISRoutineR() {
  countR++;
}

void driveServos(float _driveL, float _driveR) {
  servoL.writeMicroseconds(1500 + (int)_driveL);
  servoR.writeMicroseconds(1500 - (int)_driveR);
}

void detachServos() {
  servoL.detach();
  servoR.detach();
}
